LongTermSecret extends the OnChainSecretRPC and also holds the id and the X.

### Hierarchy

- OnChainSecretRPC
  - LongTermSecret

## Index

### Constructors

- constructor

### Properties

- X
- bc
- id
- serviceID

### Methods

- authorize
- authorizeRoster
- createLTS
- reencryptKey
- fromService
- spawn

## Constructors

### constructor

- new LongTermSecret(bc: ByzCoinRPC, id: InstanceID, X: Point, roster?: Roster): LongTermSecret

- Overrides OnChainSecretRPC.constructor

  - Defined in src/calypso/calypso-rpc.ts:131

  #### Parameters

  - ##### bc: ByzCoinRPC

  - ##### id: InstanceID

  - ##### X: Point

  - ##### Optional roster: Roster

  #### Returns LongTermSecret

## Properties

### X

X: Point

- Defined in src/calypso/calypso-rpc.ts:133

### bc

bc: ByzCoinRPC

Inherited from OnChainSecretRPC.bc

- Defined in src/calypso/calypso-rpc.ts:20

### id

id: InstanceID

- Defined in src/calypso/calypso-rpc.ts:133

### Static serviceID

serviceID: string = "Calypso"

Inherited from OnChainSecretRPC.serviceID

- Defined in src/calypso/calypso-rpc.ts:16

## Methods

### authorize

- authorize(who: ServerIdentity, bcid: InstanceID): Promise<AuthorizeReply>

- Inherited from OnChainSecretRPC.authorize

  - Defined in src/calypso/calypso-rpc.ts:56

  #### Parameters

  - ##### who: ServerIdentity

  - ##### bcid: InstanceID

  #### Returns Promise<AuthorizeReply>

### authorizeRoster

- authorizeRoster(roster?: Roster): Promise<void>

- Inherited from OnChainSecretRPC.authorizeRoster

  - Defined in src/calypso/calypso-rpc.ts:68

  authorizeRoster is a convenience method that authorizes all nodes in the bc-roster to create new LTS. For this to work, the nodes must have been started with COTHORITY_ALLOW_INSECURE_ADMIN=true

  #### Parameters

  - ##### Optional roster: Roster

    if given, this roster is used instead of the bc-roster

  #### Returns Promise<void>

### createLTS

- createLTS(r: Roster, darcID: InstanceID, signers: Signer[]): Promise<CreateLTSReply>

- Inherited from OnChainSecretRPC.createLTS

  - Defined in src/calypso/calypso-rpc.ts:32

  #### Parameters

  - ##### r: Roster

  - ##### darcID: InstanceID

  - ##### signers: Signer[]

  #### Returns Promise<CreateLTSReply>

### reencryptKey

- reencryptKey(write: Proof, read: Proof): Promise<DecryptKeyReply>

- Inherited from OnChainSecretRPC.reencryptKey

  - Defined in src/calypso/calypso-rpc.ts:80

  #### Parameters

  - ##### write: Proof

  - ##### read: Proof

  #### Returns Promise<DecryptKeyReply>

### Static fromService

- fromService(bc: ByzCoinRPC, ltsid: InstanceID, roster?: Roster): Promise<LongTermSecret>

- - Defined in src/calypso/calypso-rpc.ts:97

  fromService returns a new LongTermSecret given a ByzCoinRPC and an LTSID

  #### Parameters

  - ##### bc: ByzCoinRPC

    pointing to the ByzCoin holding the LTS definition

  - ##### ltsid: InstanceID

    which LTSID to look up

  - ##### Optional roster: Roster

    can be set if known, else the byzcoin-instance will be looked up.

  #### Returns Promise<LongTermSecret>

### Static spawn

- spawn(bc: ByzCoinRPC, darcID: InstanceID, signers: Signer[], roster?: Roster): Promise<LongTermSecret>

- - Defined in src/calypso/calypso-rpc.ts:116

  spawn creates a new longtermsecret by spawning a longTermSecret instance, and then performing a DKG using the full roster of bc.

  #### Parameters

  - ##### bc: ByzCoinRPC

    a valid ByzCoin instance

  - ##### darcID: InstanceID

    id of a darc allowed to spawn longTermSecret

  - ##### signers: Signer[]

    needed to authenticate longTermSecret spawns

  - ##### Optional roster: Roster

    if given, the roster for the DKG, if null, the full roster of bc will be used

  #### Returns Promise<LongTermSecret>

Generated using TypeDoc